<?php
/*
=====================================================
 DataLife Engine v14.0
-----------------------------------------------------
 Persian support site: https://dlefa.ir
-----------------------------------------------------
 FileName :  engine/classes/stopspam.class.php
-----------------------------------------------------
 Copyright (c) 2020, All rights reserved.
=====================================================
*/

 
 class StopSpam
 {
	
 	private $api_key;
 	private $check_level;
 	
	
 	private $endpoint = 'http://www.stopforumspam.com/';
 	
 	
 	
 	public function __construct( $api_key = null, $check_level = 1 ) {
 		// store variables
 		$this->api_key = $api_key;
 		$this->check_level = intval($check_level);
 	}
 	
 	
	public function add( $args )
	{				
		// should check first if not already in database
		
		// add api key
		$args['api_key'] = $this->api_key;
		
		// url to poll
		$url = $this->endpoint.'add.php?'.http_build_query($args, '', '&');
		
		// execute
		$response = file_get_contents($url);
		
		return (false == $response ? false : true);
	}
 	
 	
 	public function get( $args )
 	{
 		// should check first if not already in database
 		
 		// url to poll
 		$url = $this->endpoint.'api?f=json&'.http_build_query($args, '', '&');
 		
 		// 
 		return $this->poll_json( $url );
 	}
 	
 	
	public function is_spammer( $args )
	{
		// poll database
		$record = $this->get( $args );

		if( $record === false ) return false;

		// give the benefit of the doubt
		$spammer = false;

		// parse database record
		foreach( $record as $datapoint )
		{

			// not 'success' datapoint AND spammer
			if ( isset($datapoint->appears) && $datapoint->appears == true)
			{
				if( isset($datapoint->confidence) && $this->check_level > 1 ) {
					$datapoint->confidence = intval($datapoint->confidence);

					if ( $this->check_level == 2 AND $datapoint->confidence > 40 ) { $spammer = true; }

					if ( $this->check_level == 3 AND $datapoint->confidence > 80 ) { $spammer = true; }

				} else {

					$spammer = true;

				}
			}
		}

		return $spammer;
	}
 	
 	
 	protected static function poll_json( $url )
 	{
		$data = false;
			
		if( function_exists( 'curl_init' ) ) {
				
			$ch = curl_init();
			curl_setopt( $ch, CURLOPT_URL, $url );
			curl_setopt( $ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT'] );
			@curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 1 );
			curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt($ch, CURLOPT_TIMEOUT, 5);
			curl_setopt( $ch, CURLOPT_HEADER, 0);
				
			$data = curl_exec( $ch );
			curl_close( $ch );
	
			if( $data !== false ) return json_decode($data);
			
		} 

		if( preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen')) ) {
	
			$data = @file_get_contents( $url );
				
			if( $data !== false ) return json_decode($data);
	
		}
 		
 		return false;
 	}
 }
 ?>